/* Test portal engine */



#include <stdio.h>
#include <time.h>       // to compute frame rate

#include "../3dfc.h"



/* Only printf my address
**********************************************************/
void PrintContact ()
{
   printf ( "\n* Make contact if you have any questions or suggestions. Try both:\n" );
   printf ( "     lebe@aton.inf.ufrgs.br\n" );
   printf ( "     lebe@geocities.com\n" );
   printf ( "* Visit my web site to get the last version.\n" );
   printf ( "     www.geocities.com/SiliconValley/Bay/1704\n" );
}



main ( INT nNumArgs, char *szArgs [] )
{
   // verify command line options
   if ( nNumArgs == 1 ) {
      printf ( "3DFC demo - run a 3D TXE world\n" );
      printf ( "\nUse: fly  scenery_file\n\n" );
      printf ( "Example: fly demo.txe          run the world demo.txe\n\n" );
      printf ( "To exit    ESC.\n" );

      #ifdef TRG_DJGPP
      printf ( "To move    A, Z and cursor arrow keys pressed WITH ALT key pressed.\n" );
      printf ( "To rotate  7, 9 and cursor arrow keys pressed WITHOUT ALT key pressed.\n" );
      #endif

      #ifdef TRG_LINUX
      printf ( "To move    A, Z and cursor arrow keys.\n" );
      printf ( "To rotate  number keys: 7-9, 8-2, 4-6 with NUMLOCK ON.\n" );
      printf ( "\nLinux special options:\n" );
      printf ( "Use: fly  scenery_file  [ <-s CameraID Port> | <-c CameraID IPaddress Port> ]\n\n" );
      printf ( " -s         make this process work as server, wait connection\n" );
      printf ( " -c         make this process work as client, make connection\n" );
      printf ( " CameraID   the camera object, what scenery object are me\n" );
      printf ( " IPaddress  destin IP address\n" );
      printf ( " Port       the port, client and server must use the same value.\n" );
      printf ( "Example: fly demo.txe -c 1 127.0.0.1 8189    load demo.txe, client mode\n" );
      #endif
      PrintContact ();
      return 0;
   }
      
   // define scenery file to load
   CString
      oszFile = szArgs [ 1 ];

   // load scenery
   CScenery
      oScen;
   // try load and make verify load error
   if ( ! oScen.mCreate ( oszFile ) ) {
      printf ( "Scenery load error.\n" );
      return 0;
   }

   // define frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );

   // init engine
   CFly
      oFly ( oScen, 320, 200, oFrameBuffer );

   // verify if use the socket system, if yes make connection
   if ( nNumArgs > 2 ) {
      CString
         oszFlag = szArgs [ 2 ];
      // verify if this process is the client or the server
      if ( oszFlag == "-s" ) {
         // server configuration
         oFly.m_chSocketUse = 's';
         oFly.m_oszIP = "0.0.0.0";
         oFly.m_dwPort = (DWORD) atoi ( szArgs [ 4 ] ); 
         oScen.mSetCurrentCamera ( (DWORD) atoi ( szArgs [ 3 ] ),
                                   // REVIEW (pegar do objeto!)
                                   oScen.m_dwInsideObjID,
                                   oScen.m_dwInsideSecID );
         // REVIEW (bug do svgalib: soh aceita conexao em modo texto)
         printf ( "Waiting connection for 2 minutes...\n" );
         if ( ! oFly.m_oSrvSoc.mCreate ( oFly.m_oszIP, oFly.m_dwPort, 5 ) )
            ABORT ( MSG_ERROR_SOCKET_CREATION, __FILE__, __LINE__ )
         if ( oFly.m_oSrvSoc.mAccept ( 120, 0 ) )
            oFly.m_bConnected = TRUE;
      }
      else {
         // client configuration
         oFly.m_chSocketUse = 'c';
         oFly.m_oszIP = szArgs [ 4 ];
         oFly.m_dwPort = (DWORD) atoi ( szArgs [ 5 ] ); 
         oScen.mSetCurrentCamera ( (DWORD) atoi ( szArgs [ 3 ] ),
                                      oScen.m_dwInsideObjID,
                                      oScen.m_dwInsideSecID );
         printf ( "Connecting...\n" );
         if ( ! oFly.m_oCliSoc.mCreate ( oFly.m_oszIP, oFly.m_dwPort ) )
            ABORT ( MSG_ERROR_SOCKET_CREATION, __FILE__, __LINE__ )
         oFly.m_bConnected = TRUE;      
      }
   }

   // init graphics
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   
   // make printf output visible in graphics mode
   /** ( oScen.m_oPal.m_payMem + 7 * 3 + 0 ) = 50;
   * ( oScen.m_oPal.m_payMem + 7 * 3 + 1 ) = 50;
   * ( oScen.m_oPal.m_payMem + 7 * 3 + 2 ) = 50; */
   
   // change palette
   oS.mSetPalette ( oScen.m_oPal );

   // init frame rate counter
   clock_t
      stClockStart = clock ();
   DWORD
      dwFrames = 0;

   // draw frame loop
   while ( oFly.mRunFrame () ) {

      // show frame buffer on screen
      oS.mShow ( oFrameBuffer );

      // count one frame
      dwFrames ++;
   }

   // return to text mode
   oS.mDestroy ();

   // end clock count and show message
   clock_t
      stClockEnd = clock ();
   printf ( MSG_FRAMES, (float) ( stClockEnd - stClockStart ) / CLOCKS_PER_SEC, dwFrames, (float) dwFrames / ( (float) ( stClockEnd - stClockStart ) / CLOCKS_PER_SEC ) );
   PrintContact ();
}
